<?php
/** 
* Class to create additional product panel in admin 
* @package TPWCP 
* ARTURO: V.2 (Linea 179 modificado query para mostrar solo productos que tienen llaves)
*/
// Exit if accessed directly 
if( ! defined( 'ABSPATH' ) ) {
    exit;
}
if( ! class_exists( 'TPWCP_Admin' ) ) {
    class TPWCP_Admin {
        public function __construct() {
        }
        public function init() {
      	// Create the custom tab 
            add_filter( 'woocommerce_product_data_tabs', array( $this, 'create_autodispatch_tab' ) );
    		// Add the custom fields 
            add_action( 'woocommerce_product_data_panels', array( $this, 'display_autodispatch_fields' ) );
    		// Save the custom fields 
    		add_action( 'woocommerce_process_product_meta', array( $this, 'save_fields' ) );
       }
		/** 
* Add the new tab to the $tabs array 
* @see https://github.com/woocommerce/woocommerce/blob/e1a82a412773c932e76b855a97bd5ce9dedf9c44/includes/admin/meta-boxes/class-wc-meta-box-product-data.php 
* @param $tabs 
* @since 1.0.0 
*/
        public function create_autodispatch_tab( $tabs ) {
			$tabs['giftwrap'] = array(
				'label'         => __( 'Automatic Dispatch', 'waolicensemanager' ), // The name of your panel 
				'target'		=> 'gifwrap_panel', // Will be used to create an anchor link so needs to be unique 
				'class'			=> array( 'giftwrap_tab', 'show_if_simple', 'show_if_variable' ), // Class for your panel tab - helps hide/show depending on product type 
				'priority'      => 80, // Where your panel will appear. By default, 70 is last item 
			);
			return $tabs;
		}
		/** 
* Display fields for the new panel 
* @see https://docs.woocommerce.com/wc-apidocs/source-function-woocommerce_wp_checkbox.html 
* @since 1.0.0 
*/
         public function display_autodispatch_fields() { ?>
		 <style>
			.inline1{display:inline-block!important;border-right:solid gray 1px;}
			.inline1 ul li{display:inline-block!important}
			.wc-radios li{display:inline!important;padding-left:3px;padding-right:3px;}
			.no-show {display:none!important;}
		 </style>
			<div id='gifwrap_panel' class='panel woocommerce_options_panel'>
				<div class="options_group">
					<div>
					<?php
						$sino=false;
						$name=get_post($post_id);
						$auto=get_post_meta($name->ID,'_autodispatch_option');
						$co=get_post_meta($name->ID,'_combos_option');
						$combos_option=$co[0]==""?'One':$co[0];
						if($combos_option<>'One'){$clase="inline1 no-show";}else{$clase="inline1";}
						woocommerce_wp_checkbox(
							array(
								'id'		=> 'autodispatch_option',
								'label'		=> __( 'Auto dispatch option', 'waolicensemanager' ),
								'value'		=> $auto[0],
								'wrapper_class'	=> 'inline1',
								'desc_tip'	=> $sino,
								'descriptionx'	=> __( 'Select this option to activate keys autodispatch for this product', 'waolicensemanager' )
							)
						);

						 woocommerce_wp_radio( array(
							 'id'            => 'combos_option',
							 'name'            => 'combos_option',
							 'label'         => __('Products', 'tpwcp'),
							 'options'       => array(
								 'One'    => '1 Product &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;',
								 'Two'    => '2 Products &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;',
								'Four'    => '4 Products'
							 ),
							 'value'         => $combos_option
						 ) );
					?>
					</div>
					<?php
					if($auto[0]=="yes"){
						if($combos_option=="One"){
					?>
					<table class="wp-list-table widefat fixed striped table-view-list posts">
						<thead>
						<tr>
							<td>KEY CODE</td>
							<td>PRODUCT</td>
							<td>ACTIVATIONS</td>
							<td>DISPATCHED</td>
							<td>STATUS</td>
							<td>PRIORITY</td>
						</tr>
						</thead>
						<tbody>
						<?php
						///Buscar todos los registros del _product = 2430 (windows 10 pro)
						global $wpdb;
						//$claves = $wpdb->get_results( "SELECT post_id FROM {$wpdb->prefix}postmeta WHERE meta_key = '_product' AND meta_value = ".$name->ID );
						$clavesq = "SELECT ID as post_id
									FROM {$wpdb->prefix}posts
									WHERE ID IN (
									SELECT post_id FROM {$wpdb->prefix}postmeta WHERE meta_key = '_product' AND meta_value = ".$name->ID."
									)
									AND post_status = 'publish'
									ORDER BY menu_order";
						//echo  $clavesq;
						$claves = $wpdb->get_results($clavesq);
						foreach($claves as $clave){ // por cada post_id encontrado
						?>
						<tr>
							<td>
							<?php
								////$dato = "SELECT meta_value FROM {$wpdb->prefix}postmeta WHERE meta_key = '_key' AND post_id = ".$clave->post_id;
								$dato = "SELECT post_title FROM {$wpdb->prefix}posts WHERE ID = ".$clave->post_id;
								$keycode = $wpdb->get_var($dato);
								echo $keycode;
							?>
							</td>
							<td width="20%">
							<?php
								$dato = "SELECT meta_value FROM {$wpdb->prefix}postmeta M, {$wpdb->prefix}posts P WHERE meta_key = '_product' AND post_id = ".$clave->post_id;
								$salida = $wpdb->get_var($dato);
								$dato = "SELECT post_title FROM {$wpdb->prefix}posts P WHERE ID = ".$salida;
								$salida = $wpdb->get_var($dato);
								echo $salida;
							?>
							</td>
							<td>
							<?php
								$dato = "SELECT meta_value FROM {$wpdb->prefix}postmeta WHERE meta_key = '_activations' AND post_id = ".$clave->post_id;
								$salida = $wpdb->get_var($dato);
								echo $salida;
							?>
							</td>
							<td>
							<?php
								$dato = "SELECT meta_value FROM {$wpdb->prefix}postmeta WHERE meta_key = '_dispatched' AND post_id = ".$clave->post_id;
								$salida = $wpdb->get_var($dato);
								echo $salida;
							?>
							</td>
							<td>
							<?php
								$dato = "SELECT post_status FROM {$wpdb->prefix}posts WHERE ID = ".$clave->post_id;
								$salida = $wpdb->get_var($dato);
								$salida=$salida=="publish"?"Active":"Inactive";
								echo $salida;
							?>
							</td>
							<td>
							<?php
								$dato = "SELECT meta_value FROM {$wpdb->prefix}postmeta WHERE meta_key = '_priority' AND post_id = ".$clave->post_id;
								$salida = $wpdb->get_var($dato);
								echo $salida;//"<input type='radio' value='{$keycode}' id='preferred' name='preferred' ".$salida.">";
							?>
							</td>
						</tr>
						<?php
						}//fin de for bucle por cada llave
						?>
						</tbody>
					</table>
					<?php
						}else{//else if combos option one
							switch ($combos_option){
								case "Two": 
									$k=2;
									break;
								case "Four": 
									$k=4;
									break;
							}//fin de switch
							global $wpdb;
							//$q="SELECT ID, post_title FROM {$wpdb->prefix}posts WHERE `post_type` = 'product' AND `post_status` = 'publish'";
							$q="SELECT ID, post_title 
								FROM {$wpdb->prefix}posts
								WHERE post_type = 'product'
								   AND post_status = 'publish'
								   AND ID IN (
									SELECT M.meta_value
										FROM {$wpdb->prefix}posts P, {$wpdb->prefix}postmeta M
										WHERE P.post_type = 'licensemanagerwao'
										  AND P.post_status = 'publish'
										  AND P.ID = M.post_id
										  AND M.meta_key = '_product'
									);";
							$resultados=$wpdb->get_results($q);
							$opciones=array();
							foreach($resultados as $r){
								$opciones[$r->ID]=$r->post_title;
							}//fin foreach
							$prod=get_post_meta($name->ID,'_combo_products');
							for($j=0;$j<$k;$j++){
								$id_1 = "combo_product".$j;
								$label_1 = "Product ".($j+1);
								//$opciones = array('1'=>'uno','2'=>'dos','3'=>'tres');
								//$args = array( 'posts_per_page' => 200, 'post_status' => 'publish', 'post_type' => 'product' );
								//$postslist = new WP_Query( $args );
								woocommerce_wp_select(
									array(
										'id'		=> $id_1,
										'label'		=> __( $label_1, 'waolicensemanager' ),
										'desc_tip'	=> true,
										'description'	=> __( 'Select a woocommerce single product', 'waolicensemanager' ),
										'value'		=> $prod[0][$j],
										'options'	=> $opciones
									)
								);
								
							}//fin for
						}//fin if combos option one
					}//fin si autodispatch yes (fin de tabla)
					?>
					<div><hr>
					<?php
					if($combos_option=="One"){
						$auto=get_post_meta($name->ID,'_download_link');
						woocommerce_wp_text_input(
							array(
								'id'		=> 'download_link',
								'label'		=> __( 'Link for manuals and downloads', 'waolicensemanager' ),
								'type'		=> 'text',
								'value'		=> $auto[0],
								'desc_tip'	=> true,
								'description'	=> __( 'Write de URL for manuals and downloads', 'waolicensemanager' )
							)
						);

						$auto=get_post_meta($name->ID,'_product_name');
						woocommerce_wp_text_input(
							array(
								'id'		=> 'product_name',
								'label'		=> __( 'Product Name for invoice', 'waolicensemanager' ),
								'placeholder'   => $name->post_title,
								'value'		=> $auto[0],
								'type'		=> 'text',
								'desc_tip'	=> true,
								'description'	=> __( 'The product name as will showed in the invoice.', 'waolicensemanager' )
							)
						);
					}//fin de combos option one
					?>
					</div><hr>
					<input type="submit" name="save" id="publish" class="button button-primary button-large" style="margin-bottom:20px;" value="Update">
					<?php
						/*woocommerce_wp_text_input(
							array(
								'id'		=> 'save1',
								'placeholder'	=> __( 'Save', 'waolicensemanager' ),
								'class'		=> 'button save_attributes button-primary',
								'type'		=> 'button',
								'value'		=> 'Save'
								)
						);*/
					
					?>
				</div>
			</div>
		<?php 
		} // function end

/** 
* Save the custom fields using CRUD method 
* @param $post_id 
* @since 1.0.0 
*/
		public function save_fields( $post_id ) {
			$product = wc_get_product( $post_id );
			// Save the autodispatch_option setting 
			$autodispatch_option = isset( $_POST['autodispatch_option'] ) ? 'yes' : 'no';
			$auto=get_post_meta($post_id,'autodispatch_option');
			$combos_option = isset( $_POST['combos_option'] ) ? $_POST['combos_option'] : '';
			$download_link = isset( $_POST['download_link'] ) ? $_POST['download_link'] : '';
			$product_name = isset( $_POST['product_name'] ) ? $_POST['product_name'] : '';
			global $wpdb;
			if($combos_option<>"One"){
				switch ($combos_option){
					case "Two": 
						$k=2;
						break;
					case "Four": 
						$k=4;
						break;
				}//fin de switch
				
				for($l=0;$l<=$k-1;$l++){
					$combo_product="combo_product".$l;
					$array_products[] = isset( $_POST[$combo_product] ) ? $_POST[$combo_product] : '';
					//$array_products[]=sanitize_text_field($paso);
				}//end for
				$product->update_meta_data( '_combo_products', $array_products  ); //Los codigos de producto en array
			}
			$q1 = "SELECT post_id FROM {$wpdb->prefix}postmeta WHERE meta_key = '_product' AND meta_value = {$post_id}";
			$keys = $wpdb->get_col($q1);
			//$keys1 = implode(",",$keys[0]);
			$q2 = "UPDATE {$wpdb->prefix}postmeta SET meta_value = 0 WHERE meta_key = '_rotation' AND post_id IN ({$keys})";
//			$keys1 = $wpdb->get_results($q2);
			if($autodispatch_option=="yes"&&$auto[0]=="yes"){
				global $wpdb;
				$rotation = isset( $_POST[$rotation] ) ? $_POST[$rotation] : '';
//print_r($keys);
				if(FALSE){
					// Save the keycodes setting
					$keycode="keycode".$j;
					$paso = isset( $_POST[$keycode] ) ? $_POST[$keycode] : '';
					$array_keycodes[]=sanitize_text_field($paso);
					// Save the keyactivations setting 
					$keyactivation="keyactivation".$j;
					$paso = isset( $_POST[$keyactivation] ) ? $_POST[$keyactivation] : '';
					$array_keyactivations[]=sanitize_text_field($paso);
					// Save the keyrots setting 
					$keyrot="keyrot".$j;
					$array_keyrots[] = isset( $_POST[$keyrot] ) ? 'yes' : 'no';
				}//fin de for number of keys
				//$product->update_meta_data( 'keycodes', $array_keycodes  );
				//$product->update_meta_data( 'keyactivations', $array_keyactivations );
				//$product->update_meta_data( 'keyrot', $array_keyrots );
			}//fin if autodispatch_option
			//$product->update_meta_data( 'test', $auto[0] ); 
			$product->update_meta_data( '_autodispatch_option', sanitize_text_field( $autodispatch_option ) );
			$product->update_meta_data( '_combos_option', sanitize_text_field( $combos_option ) );//ono, two, four
			$product->update_meta_data( '_download_link', sanitize_text_field( $download_link ) );
			//$product->update_meta_data( '_product_name', sanitize_text_field( $product_name ) );//ono, two, four
			$product->update_meta_data( '_product_name', $keys1 );//ono, two, four
			$product->save();
		}// function end

    }// fin de clase
}// fin de si existe clase

